RangeBox = LibStub("AceAddon-3.0"):NewAddon("RangeBox", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")
RangeBox.Box = CreateFrame("Frame", "RangeBoxBox", UIParent, "BackdropTemplate")

RangeBox.Settings =
{	
	Show = true,
	Lock = false,
	UpdateFrequency = 50,
	Size = 6,
	Border = "Interface/DialogFrame/UI-DialogBox-Border",
	BorderThickness = 6,
	Background = "Interface/Tooltips/UI-Tooltip-Background",
	NoTargetColor = {0.0, 0.0, 0.0, 1.0},
	SpellName1 = "",
	SpellColor1 = {1.0, 0.5, 0.0, 1.0},
	SpellName2 = "",
	SpellColor2 = {0.0, 1.0, 0.0, 1.0},
	SpellName3 = "",
	SpellColor3 = {1.0, 1.0, 0.0, 1.0},
	SpellName4 = "",
	SpellColor4 = {0.0, 1.0, 1.0, 1.0},
	OutOfRangedColor = {1.0, 0.0, 0.0, 1.0},
}

local defaults =
{
	profile =
	{
		T1Show = true,
		T1Lock = false,
		T1UpdateFrequency = 50,
		T1Size = 20,
		T1Border = "Interface/DialogFrame/UI-DialogBox-Border",
		T1BorderThickness = 6,
		T1Background = "Interface/Tooltips/UI-Tooltip-Background",
		T1NoTargetColor = {0.0, 0.0, 0.0, 1.0},
		T1OutOfRangedColor = {1.0, 0.0, 0.0, 1.0},
		T1SpellName1 = "Spell / Item name 1",
		T1SpellColor1 = {1.0, 0.5, 0.0, 1.0},
		T1SpellName2 = "Spell / Item name 2",
		T1SpellColor2 = {0.0, 1.0, 0.0, 1.0},
		T1SpellName3 = "Spell / Item name 3",
		T1SpellColor3 = {1.0, 1.0, 0.0, 1.0},
		T1SpellName4 = "Spell / Item name 4",
		T1SpellColor4 = {0.0, 1.0, 1.0, 1.0},
		T2Show = true,
		T2Lock = false,
		T2UpdateFrequency = 50,
		T2Size = 20,
		T2Border = "Interface/DialogFrame/UI-DialogBox-Gold-Border",
		T2BorderThickness = 6,
		T2Background = "Interface/Tooltips/UI-Tooltip-Background",
		T2NoTargetColor = {0.0, 0.0, 0.0, 1.0},
		T2OutOfRangedColor = {1.0, 0.0, 0.0, 1.0},
		T2SpellName1 = "Spell / Item name 1",
		T2SpellColor1 = {1.0, 0.5, 0.0, 1.0},
		T2SpellName2 = "Spell / Item name 2",
		T2SpellColor2 = {0.0, 1.0, 0.0, 1.0},
		T2SpellName3 = "Spell / Item name 3",
		T2SpellColor3 = {1.0, 1.0, 0.0, 1.0},
		T2SpellName4 = "Spell / Item name 4",
		T2SpellColor4 = {0.0, 1.0, 1.0, 1.0},
	}
}

local borders =
{
	["Interface/AchievementFrame/UI-Achievement-WoodBorder"] = "Blizzard Achievement Wood",
	["Interface/Tooltips/ChatBubble-Backdrop"] = "Blizzard Chat Bubble",
	["Interface/DialogFrame/UI-DialogBox-Border"] = "Blizzard Dialog",
	["Interface/DialogFrame/UI-DialogBox-Gold-Border"] = "Blizzard Dialog Gold",
	["Interface/CHARACTERFRAME/UI-Party-Border"] = "Blizzard Party",
	["Interface/Tooltips/UI-Tooltip-Border"] = "Blizzard Tooltip",
}
local backgrounds =
{
	["Interface/AchievementFrame/UI-Achievement-Parchment-Horizontal"] = "Blizzard Parchment",
	["Interface/FrameGeneral/UI-Background-Rock"] = "Blizzard Rock",
	["Interface/Tooltips/UI-Tooltip-Background"] = "Blizzard Tooltip",
	["Interface/Buttons/WHITE8X8"] = "Solid",
}
local options =
{
	name = "RangeBox",
	handler = RangeBox,
	type = "group",
	childGroups = "tab",
	args =
	{
		Talent1 =
		{
			name = "Talent 1",
			type = "group",
			order = 1,
			args =
			{
				T1Show =
				{
					name = "Show",
					desc = "Show / Hide the range box.",
					type = "toggle",
					order = 5,
					width = "full",
					get = function(info) return RangeBox.db.profile.T1Show end,
					set = "SetT1Show",
				},
				T1Lock =
				{
					name = "Lock",
					desc = "Lock / unlock the range box.",
					type = "toggle",
					order = 10,
					width = "full",
					get = function(info) return RangeBox.db.profile.T1Lock end,
					set = "SetT1Lock",
				},
				T1UpdateFrequency =
				{
					name = "Update Frequency (ms)",
					desc = "Set how often the addon updates the indicator (1000=1 sec).",
					type = "range",
					min = 10,
					max = 1000,
					step = 10,
					order = 12,
					width = 1.25,
					get = function(info) return RangeBox.db.profile.T1UpdateFrequency end,
					set = "SetT1UpdateFrequency",
				},
				T1Break0 =
				{
					name = "",
					type = "description",
					order = 13,
				},
				T1Size =
				{
					name = "Size",
					desc = "Set the size of the range box (5-100).",
					type = "range",
					min = 10,
					max = 100,
					step = 1,
					order = 15,
					width = 1.25,
					get = function(info) return RangeBox.db.profile.T1Size end,
					set = "SetT1Size",
				},
				T1Break1 =
				{
					name = "",
					type = "description",
					order = 17,
				},
				T1Border =
				{
					name = "Border",
					desc = "Border of the RangeBox",
					type = "select",
					values = borders,
					order = 20,
					width = 1.25,
					get = function(info) return RangeBox.db.profile.T1Border end,
					set = "SetT1Border",
				},
				T1BorderThickness =
				{
					name = "Border Thickness",
					desc = "Thickness of the Border.",
					type = "range",
					min = 1,
					max = 16,
					step = 1,
					order = 21,
					width = 1.25,
					get = function(info) return RangeBox.db.profile.T1BorderThickness end,
					set = "SetT1BorderThickness",
				},
				T1Background =
				{
					name = "Background",
					desc = "Background of the RangeBox",
					type = "select",
					values = backgrounds,
					order = 22,
					width = 1.25,
					get = function(info) return RangeBox.db.profile.T1Background end,
					set = "SetT1Background",
				},
				T1Line1 =
				{
					name = "",
					type = "header",
					order = 23,
				},
				T1NoTargetColor =
				{
					name = "No Target Color",
					desc = "Color of the range box if there is no target.",
					type = "color",
					hasAlpha = true,
					order = 25,
					width = "full",
					get = function(info) return RangeBox.db.profile.T1NoTargetColor[1],
						RangeBox.db.profile.T1NoTargetColor[2],
						RangeBox.db.profile.T1NoTargetColor[3],
						RangeBox.db.profile.T1NoTargetColor[4] end,
					set = "SetT1NoTargetColor",
				},
				T1OutOfRangedColor =
				{
					name = "Out of Ranged Color",
					desc = "Color of the range box if the target is out of ranged.",
					type = "color",
					hasAlpha = true,
					order = 30,
					width = "full",
					get = function(info) return RangeBox.db.profile.T1OutOfRangedColor[1],
						RangeBox.db.profile.T1OutOfRangedColor[2],
						RangeBox.db.profile.T1OutOfRangedColor[3],
						RangeBox.db.profile.T1OutOfRangedColor[4] end,
					set = "SetT1OutOfRangedColor",
				},
				T1SpellColor1 =
				{
					name = "",
					desc = "Color of the range box if Spell 1 is in ranged.",
					type = "color",
					hasAlpha = true,
					order = 35,
					width = 0.1,
					get = function(info) return RangeBox.db.profile.T1SpellColor1[1],
						RangeBox.db.profile.T1SpellColor1[2],
						RangeBox.db.profile.T1SpellColor1[3],
						RangeBox.db.profile.T1SpellColor1[4] end,
					set = "SetT1SpellColor1",
				},
				T1SpellName1 =
				{
					name = "Spell / Item 1 (Farthest)",
					desc = "Name of the 1st spell or item to check for range.",
					type = "input",
					order = 40,
					width = 1.25,
					get = function(info) return RangeBox.db.profile.T1SpellName1 end,
					set = "SetT1SpellName1",
				},
				T1Break2 =
				{
					name = "",
					type = "description",
					order = 42,
				},
				T1SpellColor2 =
				{
					name = "",
					desc = "Color of the range box if Spell 2 is in ranged.",
					type = "color",
					hasAlpha = true,
					order = 45,
					width = 0.1,
					get = function(info) return RangeBox.db.profile.T1SpellColor2[1],
						RangeBox.db.profile.T1SpellColor2[2],
						RangeBox.db.profile.T1SpellColor2[3],
						RangeBox.db.profile.T1SpellColor2[4] end,
					set = "SetT1SpellColor2",
				},
				T1SpellName2 =
				{
					name = "Spell / Item 2",
					desc = "Name of the 2nd spell or item to check for range.",
					type = "input",
					order = 50,
					width = 1.25,
					get = function(info) return RangeBox.db.profile.T1SpellName2 end,
					set = "SetT1SpellName2",
				},
				T1Break3 =
				{
					name = "",
					type = "description",
					order = 52,
				},
				T1SpellColor3 =
				{
					name = "",
					desc = "Color of the range box if Spell 3 is in ranged.",
					type = "color",
					hasAlpha = true,
					order = 55,
					width = 0.1,
					get = function(info) return RangeBox.db.profile.T1SpellColor3[1],
						RangeBox.db.profile.T1SpellColor3[2],
						RangeBox.db.profile.T1SpellColor3[3],
						RangeBox.db.profile.T1SpellColor3[4] end,
					set = "SetT1SpellColor3",
				},
				T1SpellName3 =
				{
					name = "Spell / Item 3",
					desc = "Name of the 3rd spell or item to check for range.",
					type = "input",
					order = 60,
					width = 1.25,
					get = function(info) return RangeBox.db.profile.T1SpellName3 end,
					set = "SetT1SpellName3",
				},
				T1Break4 =
				{
					name = "",
					type = "description",
					order = 62,
				},
				T1SpellColor4 =
				{
					name = "",
					desc = "Color of the range box if Spell 4 is in ranged.",
					type = "color",
					hasAlpha = true,
					order = 65,
					width = 0.1,
					get = function(info) return RangeBox.db.profile.T1SpellColor4[1],
						RangeBox.db.profile.T1SpellColor4[2],
						RangeBox.db.profile.T1SpellColor4[3],
						RangeBox.db.profile.T1SpellColor4[4] end,
					set = "SetT1SpellColor4",
				},
				T1SpellName4 =
				{
					name = "Spell / Item 4 (Nearest)",
					desc = "Name of the 4th spell or item to check for range.",
					type = "input",
					order = 70,
					width = 1.25,
					get = function(info) return RangeBox.db.profile.T1SpellName4 end,
					set = "SetT1SpellName4",
				},
			},
		},
		Talent2 =
		{
			name = "Talent 2",
			type = "group",
			order = 10,
			args =
			{
				T2Show =
				{
					name = "Show",
					desc = "Show / Hide the range box.",
					type = "toggle",
					order = 5,
					width = "full",
					get = function(info) return RangeBox.db.profile.T2Show end,
					set = "SetT2Show",
				},
				T2Lock =
				{
					name = "Lock",
					desc = "Lock / unlock the range box.",
					type = "toggle",
					order = 10,
					width = "full",
					get = function(info) return RangeBox.db.profile.T2Lock end,
					set = "SetT2Lock",
				},
				T2UpdateFrequency =
				{
					name = "Update Frequency (ms)",
					desc = "Set how often the addon updates the indicator (1000=1 sec).",
					type = "range",
					min = 10,
					max = 1000,
					step = 10,
					order = 12,
					width = 1.25,
					get = function(info) return RangeBox.db.profile.T2UpdateFrequency end,
					set = "SetT2UpdateFrequency",
				},
				T2Break0 =
				{
					name = "",
					type = "description",
					order = 13,
				},
				T2Size =
				{
					name = "Size",
					desc = "Set the size of the range box (5-100).",
					type = "range",
					min = 10,
					max = 100,
					step = 1,
					order = 15,
					width = 1.25,
					get = function(info) return RangeBox.db.profile.T2Size end,
					set = "SetT2Size",
				},
				T2Break1 =
				{
					name = "",
					type = "description",
					order = 17,
				},
				T2Border =
				{
					name = "Border",
					desc = "Border of the RangeBox",
					type = "select",
					values = borders,
					order = 20,
					width = 1.25,
					get = function(info) return RangeBox.db.profile.T2Border end,
					set = "SetT2Border",
				},
				T2BorderThickness =
				{
					name = "Border Thickness",
					desc = "Thickness of the Border.",
					type = "range",
					min = 1,
					max = 16,
					step = 1,
					order = 21,
					width = 1.25,
					get = function(info) return RangeBox.db.profile.T2BorderThickness end,
					set = "SetT2BorderThickness",
				},
				T2Background =
				{
					name = "Background",
					desc = "Background of the RangeBox",
					type = "select",
					values = backgrounds,
					order = 22,
					width = 1.25,
					get = function(info) return RangeBox.db.profile.T2Background end,
					set = "SetT2Background",
				},
				T2Line1 =
				{
					name = "",
					type = "header",
					order = 23,
				},
				T2NoTargetColor =
				{
					name = "No Target Color",
					desc = "Color of the range box if there is no target.",
					type = "color",
					hasAlpha = true,
					order = 25,
					width = "full",
					get = function(info) return RangeBox.db.profile.T2NoTargetColor[1],
						RangeBox.db.profile.T2NoTargetColor[2],
						RangeBox.db.profile.T2NoTargetColor[3],
						RangeBox.db.profile.T2NoTargetColor[4] end,
					set = "SetT2NoTargetColor",
				},
				T2OutOfRangedColor =
				{
					name = "Out of Ranged Color",
					desc = "Color of the range box if the target is out of ranged.",
					type = "color",
					hasAlpha = true,
					order = 30,
					width = "full",
					get = function(info) return RangeBox.db.profile.T2OutOfRangedColor[1],
						RangeBox.db.profile.T2OutOfRangedColor[2],
						RangeBox.db.profile.T2OutOfRangedColor[3],
						RangeBox.db.profile.T2OutOfRangedColor[4] end,
					set = "SetT2OutOfRangedColor",
				},
				T2SpellColor1 =
				{
					name = "",
					desc = "Color of the range box if Spell 1 is in ranged.",
					type = "color",
					hasAlpha = true,
					order = 35,
					width = 0.1,
					get = function(info) return RangeBox.db.profile.T2SpellColor1[1],
						RangeBox.db.profile.T2SpellColor1[2],
						RangeBox.db.profile.T2SpellColor1[3],
						RangeBox.db.profile.T2SpellColor1[4] end,
					set = "SetT2SpellColor1",
				},
				T2SpellName1 =
				{
					name = "Spell / Item 1 (Farthest)",
					desc = "Name of the 1st spell or item to check for range.",
					type = "input",
					order = 40,
					width = 1.25,
					get = function(info) return RangeBox.db.profile.T2SpellName1 end,
					set = "SetT2SpellName1",
				},
				T2Break2 =
				{
					name = "",
					type = "description",
					order = 42,
				},
				T2SpellColor2 =
				{
					name = "",
					desc = "Color of the range box if Spell 2 is in ranged.",
					type = "color",
					hasAlpha = true,
					order = 45,
					width = 0.1,
					get = function(info) return RangeBox.db.profile.T2SpellColor2[1],
						RangeBox.db.profile.T2SpellColor2[2],
						RangeBox.db.profile.T2SpellColor2[3],
						RangeBox.db.profile.T2SpellColor2[4] end,
					set = "SetT2SpellColor2",
				},
				T2SpellName2 =
				{
					name = "Spell / Item 2",
					desc = "Name of the 2nd spell or item to check for range.",
					type = "input",
					order = 50,
					width = 1.25,
					get = function(info) return RangeBox.db.profile.T2SpellName2 end,
					set = "SetT2SpellName2",
				},
				T2Break3 =
				{
					name = "",
					type = "description",
					order = 52,
				},
				T2SpellColor3 =
				{
					name = "",
					desc = "Color of the range box if Spell 3 is in ranged.",
					type = "color",
					hasAlpha = true,
					order = 55,
					width = 0.1,
					get = function(info) return RangeBox.db.profile.T2SpellColor3[1],
						RangeBox.db.profile.T2SpellColor3[2],
						RangeBox.db.profile.T2SpellColor3[3],
						RangeBox.db.profile.T2SpellColor3[4] end,
					set = "SetT2SpellColor3",
				},
				T2SpellName3 =
				{
					name = "Spell / Item 3",
					desc = "Name of the 3rd spell or item to check for range.",
					type = "input",
					order = 60,
					width = 1.25,
					get = function(info) return RangeBox.db.profile.T2SpellName3 end,
					set = "SetT2SpellName3",
				},
				T2Break4 =
				{
					name = "",
					type = "description",
					order = 62,
				},
				T2SpellColor4 =
				{
					name = "",
					desc = "Color of the range box if Spell 4 is in ranged.",
					type = "color",
					hasAlpha = true,
					order = 65,
					width = 0.1,
					get = function(info) return RangeBox.db.profile.T2SpellColor4[1],
						RangeBox.db.profile.T2SpellColor4[2],
						RangeBox.db.profile.T2SpellColor4[3],
						RangeBox.db.profile.T2SpellColor4[4] end,
					set = "SetT2SpellColor4",
				},
				T2SpellName4 =
				{
					name = "Spell / Item 4 (Nearest)",
					desc = "Name of the 4th spell or item to check for range.",
					type = "input",
					order = 70,
					width = 1.25,
					get = function(info) return RangeBox.db.profile.T2SpellName4 end,
					set = "SetT2SpellName4",
				},
			},
		},
	},
}

function RangeBox:SetT1Show(info, value)
	RangeBox.db.profile.T1Show = not RangeBox.db.profile.T1Show
	
	if (GetActiveTalentGroup(false, false) == 1) then
		if not(RangeBox.db.profile.T1Show) then
			RangeBox.Settings.Show = false
			RangeBox.Box:SetAlpha(0.0)
			RangeBox.Box:SetScript("OnUpdate", nil)
		else
			RangeBox.Settings.Show = true
			RangeBox.Box:SetAlpha(1.0)
			RangeBox.Box:SetScript("OnUpdate", RangeBox.OnUpdate)
		end
	end
end

function RangeBox:SetT1Lock(info, value)
	RangeBox.db.profile.T1Lock = not RangeBox.db.profile.T1Lock

	if (GetActiveTalentGroup(false, false) == 1) then
		RangeBox.Settings.Lock = RangeBox.db.profile.T1Lock
	end
end

function RangeBox:SetT1UpdateFrequency(info, value)
	RangeBox.db.profile.T1UpdateFrequency = value

	if (GetActiveTalentGroup(false, false) == 1) then
		RangeBox.Settings.UpdateFrequency = value
		RangeBox.CancelTimer(RangeBox.UpdateTimer)
		RangeBox.UpdateTimer = RangeBox:ScheduleRepeatingTimer("OnUpdate", (value/1000))
	end
end

function RangeBox:SetT1Size(info, value)
	RangeBox.db.profile.T1Size = value

	if (GetActiveTalentGroup(false, false) == 1) then
		RangeBox.Settings.Size = value
		RangeBox.Box:SetWidth(value)
		RangeBox.Box:SetHeight(value)
	
		RangeBox.Box.Redraw()
	end
end

function RangeBox:SetT1Border(info, value)
	RangeBox.db.profile.T1Border = value
	
	if (GetActiveTalentGroup(false, false) == 1) then
		RangeBox.Settings.Border = value
		RangeBox.Box.Redraw()
	end
end

function RangeBox:SetT1BorderThickness(info, value)
	RangeBox.db.profile.T1BorderThickness = value

	if (GetActiveTalentGroup(false, false) == 1) then
		RangeBox.Settings.BorderThickness = value
		RangeBox.Box.Redraw()
	end
end

function RangeBox:SetT1Background(info, value)
	RangeBox.db.profile.T1Background = value

	if (GetActiveTalentGroup(false, false) == 1) then
		RangeBox.Settings.Background = value
		RangeBox.Box.Redraw()
	end
end

function RangeBox:SetT1NoTargetColor(info, r, g, b, a)
	RangeBox.db.profile.T1NoTargetColor = {r, g, b, a}

	if (GetActiveTalentGroup(false, false) == 1) then
		RangeBox.Settings.NoTargetColor = {r, g, b, a}
		RangeBox.Box.Redraw()
	end
end

function RangeBox:SetT1OutOfRangedColor(info, r, g, b, a)
	RangeBox.db.profile.T1OutOfRangedColor = {r, g, b, a}
	
	if (GetActiveTalentGroup(false, false) == 1) then
		RangeBox.Settings.OutOfRangedColor = {r, g, b, a}
	end
end

function RangeBox:SetT1SpellColor1(info, r, g, b, a)
	RangeBox.db.profile.T1SpellColor1 = {r, g, b, a}

	if (GetActiveTalentGroup(false, false) == 1) then
		RangeBox.Settings.SpellColor1 = {r, g, b, a}
	end
end

function RangeBox:SetT1SpellName1(info, value)
	RangeBox.db.profile.T1SpellName1 = value

	if (GetActiveTalentGroup(false, false) == 1) then
		RangeBox.Settings.SpellName1 = value
	end
end

function RangeBox:SetT1SpellColor2(info, r, g, b, a)
	RangeBox.db.profile.T1SpellColor2 = {r, g, b, a}

	if (GetActiveTalentGroup(false, false) == 1) then
		RangeBox.Settings.SpellColor2 = {r, g, b, a}
	end
end

function RangeBox:SetT1SpellName2(info, value)
	RangeBox.db.profile.T1SpellName2 = value

	if (GetActiveTalentGroup(false, false) == 1) then
		RangeBox.Settings.SpellName2 = value
	end
end

function RangeBox:SetT1SpellColor3(info, r, g, b, a)
	RangeBox.db.profile.T1SpellColor3 = {r, g, b, a}

	if (GetActiveTalentGroup(false, false) == 1) then
		RangeBox.Settings.SpellColor3 = {r, g, b, a}
	end
end

function RangeBox:SetT1SpellName3(info, value)
	RangeBox.db.profile.T1SpellName3 = value

	if (GetActiveTalentGroup(false, false) == 1) then
		RangeBox.Settings.SpellName3 = value
	end
end

function RangeBox:SetT1SpellColor4(info, r, g, b, a)
	RangeBox.db.profile.T1SpellColor4 = {r, g, b, a}

	if (GetActiveTalentGroup(false, false) == 1) then
		RangeBox.Settings.SpellColor4 = {r, g, b, a}
	end
end

function RangeBox:SetT1SpellName4(info, value)
	RangeBox.db.profile.T1SpellName4 = value

	if (GetActiveTalentGroup(false, false) == 1) then
		RangeBox.Settings.SpellName4 = value
	end
end

function RangeBox:SetT2Show(info, value)
	RangeBox.db.profile.T2Show = not RangeBox.db.profile.T2Show
	
	if (GetActiveTalentGroup(false, false) == 2) then
		if not(RangeBox.db.profile.T2Show) then
			RangeBox.Settings.Show = false
			RangeBox.Box:SetAlpha(0.0)
			RangeBox.Box:SetScript("OnUpdate", nil)
		else
			RangeBox.Settings.Show = true
			RangeBox.Box:SetAlpha(1.0)
			RangeBox.Box:SetScript("OnUpdate", RangeBox.OnUpdate)
		end
	end
end

function RangeBox:SetT2Lock(info, value)
	RangeBox.db.profile.T2Lock = not RangeBox.db.profile.T2Lock

	if (GetActiveTalentGroup(false, false) == 2) then
		RangeBox.Settings.Lock = RangeBox.db.profile.T2Lock
	end
end

function RangeBox:SetT2UpdateFrequency(info, value)
	RangeBox.db.profile.T2UpdateFrequency = value

	if (GetActiveTalentGroup(false, false) == 2) then
		RangeBox.Settings.UpdateFrequency = value
		RangeBox.CancelTimer(RangeBox.UpdateTimer)
		RangeBox.UpdateTimer = RangeBox:ScheduleRepeatingTimer("OnUpdate", (value/1000))
	end
end

function RangeBox:SetT2Size(info, value)
	RangeBox.db.profile.T2Size = value

	if (GetActiveTalentGroup(false, false) == 2) then
		RangeBox.Settings.Size = value
		RangeBox.Box:SetWidth(value)
		RangeBox.Box:SetHeight(value)
	
		RangeBox.Box.Redraw()
	end
end

function RangeBox:SetT2Border(info, value)
	RangeBox.db.profile.T2Border = value
	
	if (GetActiveTalentGroup(false, false) == 2) then
		RangeBox.Settings.Border = value
		RangeBox.Box.Redraw()
	end
end

function RangeBox:SetT2BorderThickness(info, value)
	RangeBox.db.profile.T2BorderThickness = value

	if (GetActiveTalentGroup(false, false) == 2) then
		RangeBox.Settings.BorderThickness = value
		RangeBox.Box.Redraw()
	end
end

function RangeBox:SetT2Background(info, value)
	RangeBox.db.profile.T2Background = value

	if (GetActiveTalentGroup(false, false) == 2) then
		RangeBox.Settings.Background = value
		RangeBox.Box.Redraw()
	end
end

function RangeBox:SetT2NoTargetColor(info, r, g, b, a)
	RangeBox.db.profile.T2NoTargetColor = {r, g, b, a}

	if (GetActiveTalentGroup(false, false) == 2) then
		RangeBox.Settings.NoTargetColor = {r, g, b, a}
		RangeBox.Box.Redraw()
	end
end

function RangeBox:SetT2OutOfRangedColor(info, r, g, b, a)
	RangeBox.db.profile.T2OutOfRangedColor = {r, g, b, a}
	
	if (GetActiveTalentGroup(false, false) == 2) then
		RangeBox.Settings.OutOfRangedColor = {r, g, b, a}
	end
end

function RangeBox:SetT2SpellColor1(info, r, g, b, a)
	RangeBox.db.profile.T2SpellColor1 = {r, g, b, a}

	if (GetActiveTalentGroup(false, false) == 2) then
		RangeBox.Settings.SpellColor1 = {r, g, b, a}
	end
end

function RangeBox:SetT2SpellName1(info, value)
	RangeBox.db.profile.T2SpellName1 = value

	if (GetActiveTalentGroup(false, false) == 2) then
		RangeBox.Settings.SpellName1 = value
	end
end

function RangeBox:SetT2SpellColor2(info, r, g, b, a)
	RangeBox.db.profile.T2SpellColor2 = {r, g, b, a}

	if (GetActiveTalentGroup(false, false) == 2) then
		RangeBox.Settings.SpellColor2 = {r, g, b, a}
	end
end

function RangeBox:SetT2SpellName2(info, value)
	RangeBox.db.profile.T2SpellName2 = value

	if (GetActiveTalentGroup(false, false) == 2) then
		RangeBox.Settings.SpellName2 = value
	end
end

function RangeBox:SetT2SpellColor3(info, r, g, b, a)
	RangeBox.db.profile.T2SpellColor3 = {r, g, b, a}

	if (GetActiveTalentGroup(false, false) == 2) then
		RangeBox.Settings.SpellColor3 = {r, g, b, a}
	end
end

function RangeBox:SetT2SpellName3(info, value)
	RangeBox.db.profile.T2SpellName3 = value

	if (GetActiveTalentGroup(false, false) == 2) then
		RangeBox.Settings.SpellName3 = value
	end
end

function RangeBox:SetT2SpellColor4(info, r, g, b, a)
	RangeBox.db.profile.T2SpellColor4 = {r, g, b, a}

	if (GetActiveTalentGroup(false, false) == 2) then
		RangeBox.Settings.SpellColor4 = {r, g, b, a}
	end
end

function RangeBox:SetT2SpellName4(info, value)
	RangeBox.db.profile.T2SpellName4 = value

	if (GetActiveTalentGroup(false, false) == 2) then
		RangeBox.Settings.SpellName4 = value
	end
end

function RangeBox:ChatCommand(input)
	if not input or input:trim() == "" then
		LibStub("AceConfigDialog-3.0"):Open("RangeBox")
	else
		LibStub("AceConfigCmd-3.0"):HandleCommand("rb2", "RangeBox", input)
	end
end

function RangeBox:ACTIVE_TALENT_GROUP_CHANGED()
	if (GetActiveTalentGroup(false, false) == 1) then
		RangeBox.Settings.Show = RangeBox.db.profile.T1Show
		RangeBox.Settings.Lock = RangeBox.db.profile.T1Lock
		RangeBox.Settings.UpdateFrequency = RangeBox.db.profile.T1UpdateFrequency
		RangeBox.Settings.Size = RangeBox.db.profile.T1Size
		RangeBox.Settings.Background = RangeBox.db.profile.T1Background
		RangeBox.Settings.Border = RangeBox.db.profile.T1Border
		RangeBox.Settings.BorderThickness = RangeBox.db.profile.T1BorderThickness
		RangeBox.Settings.NoTargetColor = RangeBox.db.profile.T1NoTargetColor
		RangeBox.Settings.SpellName1 = RangeBox.db.profile.T1SpellName1
		RangeBox.Settings.SpellColor1 = RangeBox.db.profile.T1SpellColor1
		RangeBox.Settings.SpellName2 = RangeBox.db.profile.T1SpellName2
		RangeBox.Settings.SpellColor2 = RangeBox.db.profile.T1SpellColor2
		RangeBox.Settings.SpellName3 = RangeBox.db.profile.T1SpellName3
		RangeBox.Settings.SpellColor3 = RangeBox.db.profile.T1SpellColor3
		RangeBox.Settings.SpellName4 = RangeBox.db.profile.T1SpellName4
		RangeBox.Settings.SpellColor4 = RangeBox.db.profile.T1SpellColor4
		RangeBox.Settings.OutOfRangedColor = RangeBox.db.profile.T1OutOfRangedColor
	else
		RangeBox.Settings.Show = RangeBox.db.profile.T2Show
		RangeBox.Settings.Lock = RangeBox.db.profile.T2Lock
		RangeBox.Settings.UpdateFrequency = RangeBox.db.profile.T2UpdateFrequency
		RangeBox.Settings.Size = RangeBox.db.profile.T2Size
		RangeBox.Settings.Background = RangeBox.db.profile.T2Background
		RangeBox.Settings.Border = RangeBox.db.profile.T2Border
		RangeBox.Settings.BorderThickness = RangeBox.db.profile.T2BorderThickness
		RangeBox.Settings.NoTargetColor = RangeBox.db.profile.T2NoTargetColor
		RangeBox.Settings.SpellName1 = RangeBox.db.profile.T2SpellName1
		RangeBox.Settings.SpellColor1 = RangeBox.db.profile.T2SpellColor1
		RangeBox.Settings.SpellName2 = RangeBox.db.profile.T2SpellName2
		RangeBox.Settings.SpellColor2 = RangeBox.db.profile.T2SpellColor2
		RangeBox.Settings.SpellName3 = RangeBox.db.profile.T2SpellName3
		RangeBox.Settings.SpellColor3 = RangeBox.db.profile.T2SpellColor3
		RangeBox.Settings.SpellName4 = RangeBox.db.profile.T2SpellName4
		RangeBox.Settings.SpellColor4 = RangeBox.db.profile.T2SpellColor4
		RangeBox.Settings.OutOfRangedColor = RangeBox.db.profile.T2OutOfRangedColor
	end
	
	RangeBox.Box.Redraw()
end

function RangeBox:OnInitialize()
	-- Load default option values
	self.db = LibStub("AceDB-3.0"):New("RangeBoxDB", defaults)
	
	-- Create Options frame
	LibStub("AceConfig-3.0"):RegisterOptionsTable("RangeBox", options)
	
	-- Add Profile tab to Options frame
	options.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	
	-- Add options frame to the Blizzard Options Menu
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("RangeBox")

	self:RegisterChatCommand("RangeBox", "ChatCommand")
	self:RegisterChatCommand("rb", "ChatCommand")
	
	self:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");
	
	RangeBox.ACTIVE_TALENT_GROUP_CHANGED()
	RangeBox.Box.Initialize()
end

function RangeBox:OnEnable()
end

function RangeBox:OnDisable()
end
