function RangeBox.Box.Initialize()
	RangeBox.Box:SetFrameStrata("BACKGROUND")
	RangeBox.Box:SetWidth(RangeBox.Settings.Size)
	RangeBox.Box:SetHeight(RangeBox.Settings.Size)
	RangeBox.Box:SetPoint("CENTER", 0, 0)

	RangeBox.Box.Redraw()
	
	RangeBox.Box:SetMovable(true)
	RangeBox.Box:EnableMouse(true)
	RangeBox.Box:RegisterForDrag("LeftButton")
	RangeBox.Box:SetScript("OnDragStart", RangeBox.Box.OnDragStart)
	RangeBox.Box:SetScript("OnDragStop", RangeBox.Box.OnDragStop)

	RangeBox.UpdateTimer = RangeBox:ScheduleRepeatingTimer("OnUpdate", (RangeBox.Settings.UpdateFrequency/1000))
	
	if not(RangeBox.Settings.Show) then
		RangeBox.Box:SetAlpha(0.0)
	else
		RangeBox.Box:SetAlpha(1.0)
	end
	
	RangeBox.Box:Show()
end

function RangeBox.Box.OnDragStart()
	if not(RangeBox.Settings.Lock) then
		RangeBox.Box:StartMoving()
	end
end

function RangeBox.Box.OnDragStop()
	 RangeBox.Box:StopMovingOrSizing()
end

function RangeBox.OnUpdate(self, elapsed)	
	if not(UnitExists("target")) then
		RangeBox.Box:SetBackdropColor(RangeBox.Settings.NoTargetColor[1], RangeBox.Settings.NoTargetColor[2], RangeBox.Settings.NoTargetColor[3], RangeBox.Settings.NoTargetColor[4])
	else
		if UnitCanAttack("player", "target") and UnitIsVisible("target") and not(UnitIsDead("target")) then
			if ((IsSpellInRange(RangeBox.Settings.SpellName4, "target")==1) or (IsItemInRange(RangeBox.Settings.SpellName4, "target"))) then
				RangeBox.Box:SetBackdropColor(RangeBox.Settings.SpellColor4[1],
												RangeBox.Settings.SpellColor4[2],
												RangeBox.Settings.SpellColor4[3],
												RangeBox.Settings.SpellColor4[4])
			elseif ((IsSpellInRange(RangeBox.Settings.SpellName3, "target")==1) or (IsItemInRange(RangeBox.Settings.SpellName3, "target"))) then
				RangeBox.Box:SetBackdropColor(RangeBox.Settings.SpellColor3[1],
												RangeBox.Settings.SpellColor3[2],
												RangeBox.Settings.SpellColor3[3],
												RangeBox.Settings.SpellColor3[4])
			elseif ((IsSpellInRange(RangeBox.Settings.SpellName2, "target")==1) or (IsItemInRange(RangeBox.Settings.SpellName2, "target"))) then
				RangeBox.Box:SetBackdropColor(RangeBox.Settings.SpellColor2[1],
												RangeBox.Settings.SpellColor2[2],
												RangeBox.Settings.SpellColor2[3],
												RangeBox.Settings.SpellColor2[4])
			elseif ((IsSpellInRange(RangeBox.Settings.SpellName1, "target")==1) or (IsItemInRange(RangeBox.Settings.SpellName1, "target"))) then
				RangeBox.Box:SetBackdropColor(RangeBox.Settings.SpellColor1[1],
												RangeBox.Settings.SpellColor1[2],
												RangeBox.Settings.SpellColor1[3],
												RangeBox.Settings.SpellColor1[4])
			else
				RangeBox.Box:SetBackdropColor(RangeBox.Settings.OutOfRangedColor[1],
												RangeBox.Settings.OutOfRangedColor[2],
												RangeBox.Settings.OutOfRangedColor[3],
												RangeBox.Settings.OutOfRangedColor[4])
			end
		end
	end
end

function RangeBox.Box.Redraw()
	RangeBox.Box:SetWidth(RangeBox.Settings.Size)
	RangeBox.Box:SetHeight(RangeBox.Settings.Size)
	
	RangeBox.Box:SetBackdrop({
		bgFile = RangeBox.Settings.Background, 
		edgeFile = RangeBox.Settings.Border, 
		tile = true, tileSize=4, edgeSize=RangeBox.Settings.BorderThickness, 
		insets = {left=2, right=2, top=2, bottom=2}
	})
	RangeBox.Box:SetBackdropColor(RangeBox.Settings.NoTargetColor[1],
									RangeBox.Settings.NoTargetColor[2],
									RangeBox.Settings.NoTargetColor[3],
									RangeBox.Settings.NoTargetColor[4])
end